package client;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import java.net.InetSocketAddress;
import java.net.Socket;


import server.IFile;


public class Stub {
	Object stub;
	InetSocketAddress address;
	
	public Stub(InetSocketAddress address, Class<IFile> intf) {
		this.address = address;
		stub = Proxy.newProxyInstance(intf.getClassLoader(),
                                                new Class[] {intf},
                                                new StubInvocationHandler());
	}
	
	public Object getStub() {
		return this.stub;
	}

	class StubInvocationHandler implements InvocationHandler {
		// this is buggy
//		 Socket              socket = null;
//         ObjectOutputStream  out = null;
//         ObjectInputStream   in = null;
         
		
		@Override
		public Object invoke(Object stub, Method method, Object[] args) throws Throwable {
			Object result = null;
			
            // Socket and streams.
            Socket              socket = null;
            ObjectOutputStream  out = null;
            ObjectInputStream   in = null;
            try {
                socket = new Socket();            	
				socket.connect(address);
				out = new ObjectOutputStream(socket.getOutputStream());
				in = new ObjectInputStream(socket.getInputStream());
				
				out.writeObject(method.getName());				
				out.writeObject(method.getParameterTypes());				
 			   	out.writeObject(args);
 			   	out.flush();
 			   	
 			   	result = in.readObject();
 			   	System.out.println("result:" + result);
			
			} catch (IOException | ClassNotFoundException e) {
				e.printStackTrace();
			} finally {
				socket.close();
				out.close();
				in.close();
			}
			return result;			
		}
		
	}
		

}
