package server;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;

public class Skeleton {
	InetSocketAddress address;
	ServerSocket listenSocket;
	Class<?> intf;
	Class<?> impl;
	
	
	public Skeleton(InetSocketAddress address, Class<?> intf, Class<?> impl) {
		this.intf = intf;
		this.impl = impl;
		this.address = address;
	}
	
	public void start() { 
		try {
			listenSocket = new ServerSocket();
			listenSocket.bind(address);
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		
		while (true) {
			Socket clientSocket;
			try {
				clientSocket = listenSocket.accept();
				Thread t = new Thread(new ServiceThread(clientSocket));
				t.start();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	class ServiceThread implements Runnable {
		Socket clientSocket;
		ObjectInputStream in;
		ObjectOutputStream out;
		
		ServiceThread(Socket cs) {
			this.clientSocket = cs;
			try {
				this.in = new ObjectInputStream(cs.getInputStream());
				this.out = new ObjectOutputStream(cs.getOutputStream());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		@Override
		public void run() {
			/* runs one time */
			String methodName;
			try {
				methodName = (String) in.readObject();
				Class<?>[] argTypes = (Class[]) in.readObject();
				Object[] args = (Object[]) in.readObject();
				/* invoke the method */
				System.out.println("MethodName: " + methodName);
				System.out.println("Args: " + args[0]);
				
				Method m = IFileServer.class.getDeclaredMethod(methodName, argTypes);
				
				
				
				System.out.println("m:" + m.toString());
				System.out.println("impl:" + impl);
				Object result;
				try {
					result = m.invoke(IFileServer.class.newInstance(), args);
					out.writeObject(result);
					out.flush();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}				
			} catch (ClassNotFoundException | 
					IOException | 
					NoSuchMethodException | 
					SecurityException | 
					IllegalAccessException | 
					IllegalArgumentException | 
					InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {
				try {
					in.close();
					out.close();
					clientSocket.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
